﻿package  
{
	import flash.display.Sprite;
    import caurina.transitions.Tweener;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.text.TextField;
	import flash.text.TextFormat;
	
	/**
	 * ...
	 * @author ...
	 */
	public class Disk extends Sprite
	{
		static internal var size:uint;
		static internal var tweenDelay:Number;

		private var point:Point;
		
		internal var num:uint
		
		
		public function Disk(num:uint, i:uint, j:uint) 
		{
			this.num = num;
			draw(num);

			point = new Point(i, j);
			x = 150 + size / 2 + size * j;
			y = 50 + size / 2 + size * i;
		}
		
		
		internal function moveTween(direction:String, tm:Number = 0.1):void {

			var tmp:Point = point;
			point = Main.ePoint;
			Main.ePoint = tmp;

			var tmpDisk:Disk = Main.diskList[point.x][point.y];
			Main.diskList[point.x][point.y] = Main.diskList[Main.ePoint.x][Main.ePoint.y];
			Main.diskList[Main.ePoint.x][Main.ePoint.y] = tmpDisk;
			
			if(direction == "d")
				Tweener.addTween(this, { y:y + size, time:tm, delay:tweenDelay});			
			else if(direction == "u")
				Tweener.addTween(this, { y:y - size, time:tm, delay:tweenDelay});			
			else if(direction == "r")
				Tweener.addTween(this, { x:x + size, time:tm, delay:tweenDelay});			
			else if(direction == "l")
				Tweener.addTween(this, { x:x - size, time:tm, delay:tweenDelay});			
			
			tweenDelay += 0.2;
		}
		
		
		internal function cascade(direction:String, cur:Node, end:Boolean):void {
//			trace(direction);
			var tmp:Point = point;
			point = Main.ePoint;
			Main.ePoint = tmp;

			var tmpDisk:Disk = Main.diskList[point.x][point.y];
			Main.diskList[point.x][point.y] = Main.diskList[Main.ePoint.x][Main.ePoint.y];
			Main.diskList[Main.ePoint.x][Main.ePoint.y] = tmpDisk;
			
			if(!end) {
			if(direction == "d")
				Tweener.addTween(this, { y:y + size, time:0.1, onComplete:SlidingBlock.onComplete, onCompleteParams:[cur.nextleaf]});			
			else if(direction == "u")
				Tweener.addTween(this, { y:y - size, time:0.1, onComplete:SlidingBlock.onComplete, onCompleteParams:[cur.nextleaf]});			
			else if(direction == "r")
				Tweener.addTween(this, { x:x + size, time:0.1, onComplete:SlidingBlock.onComplete, onCompleteParams:[cur.nextleaf]});			
			else if(direction == "l")
				Tweener.addTween(this, { x:x - size, time:0.1, onComplete:SlidingBlock.onComplete, onCompleteParams:[cur.nextleaf] } );					
			}
			else {
			if(direction == "d")
				Tweener.addTween(this, { y:y + size, time:0.1});			
			else if(direction == "u")
				Tweener.addTween(this, { y:y - size, time:0.1});			
			else if(direction == "r")
				Tweener.addTween(this, { x:x + size, time:0.1});			
			else if(direction == "l")
				Tweener.addTween(this, { x:x - size, time:0.1} );					
			}
				
//			trace("hoge");
		}
		
		
		static internal function operate(direction:String, delay:Boolean = true, tm:Number = 0):int {

			if (!delay)
				tweenDelay = 0;
			
			if (direction == "u" && Main.ePoint.x < Main.N - 1)
				Main.diskList[Main.ePoint.x + 1][Main.ePoint.y].moveTween(direction, tm);
			else if(direction == "d" && Main.ePoint.x > 0)
				Main.diskList[Main.ePoint.x - 1][Main.ePoint.y].moveTween(direction, tm);
			else if(direction == "l" && Main.ePoint.y < Main.N - 1)
				Main.diskList[Main.ePoint.x][Main.ePoint.y + 1].moveTween(direction, tm);
			else if(direction == "r" && Main.ePoint.y > 0)
				Main.diskList[Main.ePoint.x][Main.ePoint.y - 1].moveTween(direction, tm);
			else
				return 0;
				
			return 1;
		}

		internal function onClick(event:MouseEvent):void {
			
			Tweener.addTween(this, { x:150 + size / 2 + size * Main.ePoint.y, y:50 + size / 2 + size * Main.ePoint.x, time:0.2 } );			

			var tmp:Point = point;
			point = Main.ePoint;
			Main.ePoint = tmp;

			var tmpDisk:Disk = Main.diskList[point.x][point.y];
			Main.diskList[point.x][point.y] = Main.diskList[Main.ePoint.x][Main.ePoint.y];
			Main.diskList[Main.ePoint.x][Main.ePoint.y] = tmpDisk;

			
			for each(var v:Array in Main.diskList)
				for each(var w:Disk in v)
					if(w.buttonMode) {					
						w.buttonMode = false;
						w.removeEventListener(MouseEvent.CLICK, w.onClick);
					}
			
					
			
//			trace(Main.ePoint);
			if (Main.ePoint.x > 0) {
				Main.diskList[Main.ePoint.x - 1][Main.ePoint.y].buttonMode = true;
				Main.diskList[Main.ePoint.x - 1][Main.ePoint.y].addEventListener(MouseEvent.CLICK, Main.diskList[Main.ePoint.x - 1][Main.ePoint.y].onClick);
			}
			if (Main.ePoint.y > 0) {
				Main.diskList[Main.ePoint.x][Main.ePoint.y - 1].buttonMode = true;
				Main.diskList[Main.ePoint.x][Main.ePoint.y - 1].addEventListener(MouseEvent.CLICK, Main.diskList[Main.ePoint.x][Main.ePoint.y - 1].onClick);
			}
			if (Main.ePoint.x < Main.N - 1) {
				Main.diskList[Main.ePoint.x + 1][Main.ePoint.y].buttonMode = true;
				Main.diskList[Main.ePoint.x + 1][Main.ePoint.y].addEventListener(MouseEvent.CLICK, Main.diskList[Main.ePoint.x + 1][Main.ePoint.y].onClick);
			}
			if (Main.ePoint.y < Main.N - 1) {				
				Main.diskList[Main.ePoint.x][Main.ePoint.y + 1].buttonMode = true;
				Main.diskList[Main.ePoint.x][Main.ePoint.y + 1].addEventListener(MouseEvent.CLICK, Main.diskList[Main.ePoint.x][Main.ePoint.y + 1].onClick);
			}
		}
		
		private function draw(num:uint):void {
			
			
			var sz:uint = size * 0.9;
			
			graphics.beginFill(0xaaaaaa);
			graphics.drawRoundRect( -sz / 2, -sz / 2, sz, sz, 16);
			graphics.endFill();
			
			var tf:TextField = new TextField();
			
			if (num == 0) {
				visible = false;
				tf.visible = false;
			}	
			
			tf.textColor = 0x0000ff;
			tf.width = sz;
//			tf.height = sz;
			tf.x = -sz / 4;
			tf.y = -sz / 4;
			tf.mouseEnabled = false;
			tf.text = num.toString();

			var myTxFmt:TextFormat = new TextFormat();
			myTxFmt.size = sz / 3;
			tf.setTextFormat(myTxFmt);

			addChild(tf);
			
		}
		
	}
	
}

